Import and Export Visio files

NOTE

Visio import and export support is currently experimental. Certain features may be limited or may not function as expected.

What is Microsoft Visio?

Microsoft Visio is a diagramming application used to create visual representations such as flowcharts, organizational charts, process diagrams, and system layouts. Visio diagrams are stored in the .vsdx file format, which contains information about pages, shapes, connectors, text, and layout settings.

Why use Visio with the JavaScript Diagram?

Many organizations maintain existing diagrams created using Microsoft Visio. Recreating these diagrams in a web application can require significant effort. The Diagram control provides Visio integration to support the following scenarios:

  • Reuse existing Visio diagrams in web applications.
  • Visualize and edit Visio diagrams using the Diagram control.
  • Export diagrams created or modified in Diagram control for use in Microsoft Visio.

This integration enables seamless collaboration between desktop‑based Visio tools and web‑based diagramming applications.

Visio support in the JavaScript Diagram

The Syncfusion Essential JavaScript Diagram control supports Microsoft Visio integration by allowing .vsdx files to be imported into the Diagram control and diagrams to be exported back to Visio format. During import, Visio shapes, connectors, and annotations are mapped to their corresponding Diagram elements, while export converts the diagram content into a valid .vsdx file.

NOTE

To enable Visio import and export functionality, inject the ImportAndExportVisio module into the Diagram control.

Import Visio files in JavaScript Diagram

How Visio import works

A Visio file can be selected from the local file system or retrieved from a server or cloud storage. Once the .vsdx file is available, it is passed to the Diagram control as a File object using the importFromVisio method.

During the import process:

  • Visio pages are read.
  • Shapes are converted into Diagram nodes.
  • Connectors are converted into Diagram connectors.
  • Basic text and formatting are applied where supported.

Import a Visio file

The following example imports a Visio (.vsdx) file by passing a File object to the importFromVisio method. The method returns a collection of warnings when certain Visio features are not fully supported during import.

ej.diagrams.Diagram.Inject(ej.diagrams.ImportAndExportVisio);

var uploadObject = new ej.inputs.Uploader({
    asyncSettings: {
        saveUrl:
            'https://services.syncfusion.com/js/production/api/FileUploader/Save',
        removeUrl:
            'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
    },
    success: onUploadSuccess,
});

// render initialized Uploader
uploadObject.appendTo('#fileupload');

async function onUploadSuccess(args) {
    var file = args.file;
    var rawFile = file.rawFile;
    const warnings = await diagram.importFromVisio(rawFile, { pageIndex: 0 });
    if (warnings.length) {
        for (var i = 0; i < warnings.length - 1; i++) {
            console.warn(warnings[i]);
        }
    }

}

function diagramImporting(args) {
    if (args.status === 'started') {
        // Import has started: show a loader / disable UI
    } else if (args.status === 'completed') {
        // Import completed: hide loader / enable UI
    } else if (args.status === 'failed') {
        console.error('Visio import failed.', args);
    }
}

var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '700px',
    diagramImporting: diagramImporting
});

diagram.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body  style="margin-top: 100px;">
    
    <div id="container">
        <input type="file" id="fileupload" name="Import Files" accept=".vsdx"/>
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Import options

Import behavior can be customized using the VisioImportOptions object.

Property Description
pageIndex Specifies the zero-based index of the Visio page to import. The default value is 0.

Import lifecycle event

The diagramImporting event is triggered during the Visio import process. This event provides information about the current import status, available pages, warnings or errors, and supports page selection or cancellation of the import operation.

Event arguments:

Argument Description
status Indicates the current stage of the import operation.
pages Contains the list of available Visio pages.
selectedPage Specifies the Visio page to import.
cancel Set to true to cancel the import operation.
logs Contains warnings or errors generated during import.

NOTE

The selectedPage property is configurable only when the import status is started.

Cancel the import operation

The import operation can be canceled during the initial stage by setting the cancel property to true.

diagramImporting: function (args) {
  if (args.status === 'started') {
    args.cancel = true;
  }
}

Select a page during import

When a Visio file contains multiple pages, a specific page can be selected at the start of the import process.

diagramImporting: function (args) {
  if (args.status === 'started' && args.pages && args.pages.length) {
    args.selectedPage = args.pages[0]; // Imports the first page
  }
}

Export JavaScript Diagram to Visio

How Visio export works

The Diagram control supports exporting diagrams to Microsoft Visio format using the exportToVisio method. This method generates a .vsdx file and automatically downloads it through the browser.

Exporting a diagram

The following example exports an JavaScript Diagram to a Microsoft Visio (.vsdx) file using the exportToVisio method.

ej.diagrams.Diagram.Inject(ej.diagrams.ImportAndExportVisio);

function diagramExporting(args) {
    if (args.status === 'started') {
        // Export has started: show loader / disable UI
    }
    else if (args.status === 'completed') {
        // Export completed: hide loader / enable UI
    }
    else if (args.status === 'failed') {
        // Export failed: show error message
        console.error('Visio export failed.', args);
    }
};

var nodes = [
    {
        id: 'Start',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 200,
        annotations: [
            {
                content: 'Start',
            }
        ],
        ports: [{
            id: 'port1',
            offset: {
                x: 1,
                y: 0.5
            }
        }],
        style: { fill: '#2AA8D9', strokeColor: 'grey' }
    },
    {
        id: 'End',
        width: 100,
        height: 100,
        offsetX: 600,
        offsetY: 200,
        annotations: [
            {
                content: 'End',

            }
        ],
        style: { fill: '#2AA8D9', strokeColor: 'grey' }
    }
];

var connectors = [
    {
        id: 'connector1',
        sourceID: 'Start',
        sourcePortID: 'port1',
        targetID: 'End',
        annotations: [
            {
                content: 'Connect',
                alignment: 'Before',
                displacement: { y: 10 },
            }
        ]
    }
];
// initialize diagram component
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    nodes: nodes,
    connectors: connectors,
    diagramExporting: diagramExporting
  },

  '#element'
);

document.getElementById('export').onclick = () => {
    let exportOptions = {};
    exportOptions.fileName = 'diagram1.vsdx';
    exportOptions.pageName = 'page1';
    diagram.exportToVisio(exportOptions);
};
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-diagrams/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/fabric.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="button" id="export" value="Export" />
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Export options

Export behavior can be controlled using the VisioExportOptions object.

Property Description
fileName Specifies the name of the exported Visio file. The default value is Sample.vsdx.
pageName Specifies the name of the Visio page. The default value is Page-1.

Export lifecycle event

The diagramExporting event provides status updates, reports warnings or errors, and supports cancellation of the export operation.

Event arguments:

Argument Description
status Indicates the current stage of the export process.
cancel Set to true to cancel the export operation.
logs Contains warnings or errors generated during export.

Cancel the export operation

The export operation can be canceled at the start of the process by setting the cancel property to true.

  diagramExporting: function (args) {
    if (args.status === 'started') {
      args.cancel = true;
    }
  }

Limitations

The table below outlines Visio’s import and export limitations, offering a concise summary of current feature support and known restrictions.

Import Limitations Export Limitations
Gradient page backgrounds: Only solid fills are imported; gradient page background fills are not supported. Diagram-level tooltips: Diagram‑level tooltips are not exported.
Gradient types: Only linear and radial gradient types are supported; other gradient styles are ignored. Connector segment thumbs: Connector segment thumb customizations are not supported.
Ruler settings: Ruler settings may not be preserved accurately due to coordinate origin differences (Visio uses bottom‑left; Diagram control uses top‑left). Templates & tools: Templates and custom tool configurations are not exported.
Layer support: Only a single layer per shape is supported. Layer Z‑index ordering: Layer Z‑index ordering is not preserved.
Line styles: Rounded line caps and compound line styles are not supported. Annotation properties: Annotation displacement and flip properties are not supported.
Image formatting: Image formatting options such as brightness, contrast, and cropping are not supported. Port customization: Port customization properties are not exported.
Connector types: Only basic connector types—straight, right‑angle, and curved—are supported. Page margins & boundaries: Page margin and boundary constraints may require manual adjustment after export.
Connector gradients: Connector gradient styles are not supported.  
Multiple hyperlinks: Multiple hyperlinks within a single shape are not supported.  
Rich text: Rich text formatting is not supported; text is rendered using a single, uniform style.  
Text fill behavior: Text fill behavior may differ from Microsoft Visio.

Import and Export Visio files

NOTE

Visio import and export support is currently experimental. Certain features may be limited or may not function as expected.

What is Microsoft Visio?

Microsoft Visio is a diagramming application used to create visual representations such as flowcharts, organizational charts, process diagrams, and system layouts. Visio diagrams are stored in the .vsdx file format, which contains information about pages, shapes, connectors, text, and layout settings.

Why use Visio with the Angular Diagram?

Many organizations maintain existing diagrams created using Microsoft Visio. Recreating these diagrams in a web application can require significant effort. The Diagram component provides Visio integration to support the following scenarios:

  • Reuse existing Visio diagrams in web applications.
  • Visualize and edit Visio diagrams using the Diagram component.
  • Export diagrams created or modified in Diagram component for use in Microsoft Visio.

This integration enables seamless collaboration between desktop‑based Visio tools and web‑based diagramming applications.

Visio support in the Angular Diagram

The Syncfusion Essential Angular Diagram component supports Microsoft Visio integration by allowing .vsdx files to be imported into the Diagram component and diagrams to be exported back to Visio format. During import, Visio shapes, connectors, and annotations are mapped to their corresponding Diagram elements, while export converts the diagram content into a valid .vsdx file.

NOTE

To enable Visio import and export functionality, inject the ImportAndExportVisio module into the Diagram component.

Import Visio files in Angular Diagram

How Visio import works

A Visio file can be selected from the local file system or retrieved from a server or cloud storage. Once the .vsdx file is available, it is passed to the Diagram component as a File object using the importFromVisio method.

During the import process:

  • Visio pages are read.
  • Shapes are converted into Diagram nodes.
  • Connectors are converted into Diagram connectors.
  • Basic text and formatting are applied where supported.

Import a Visio file

The following example imports a Visio (.vsdx) file by passing a File object to the importFromVisio method. The method returns a collection of warnings when certain Visio features are not fully supported during import.

import { DiagramModule, ImportAndExportVisio, DiagramComponent, Diagram, IImportingEventArgs } from '@syncfusion/ej2-angular-diagrams';
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { Uploader } from '@syncfusion/ej2-inputs';

Diagram.Inject(ImportAndExportVisio);

@Component({
    imports: [DiagramModule],
    providers: [],
    standalone: true,
    selector: 'app-container',
    template: `
    <div> <input id="fileupload" type="file" accept=".vsdx"/>
    <ejs-diagram #diagram id="diagram" width="100%" height="700px" (diagramImporting)="diagramImporting($event)">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None,
})

export class AppComponent {
    @ViewChild('diagram')
    public diagram!: DiagramComponent;
    public uploadObject: Uploader;

    constructor() {
        this.uploadObject = new Uploader({
            asyncSettings: {
                saveUrl:
                    'https://services.syncfusion.com/js/production/api/FileUploader/Save',
                removeUrl:
                    'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
            },
            success: this.onUploadSuccess.bind(this),
        });
    };

    ngAfterViewInit() {
        this.uploadObject.appendTo('#fileupload');
    };

    public diagramImporting(args: IImportingEventArgs): void {
        if (args.status === 'started') {
            // Import has started: show a loader / disable UI
        } else if (args.status === 'completed') {
            // Import completed: hide loader / enable UI
        } else if (args.status === 'failed') {
            console.error('Visio import failed.', args);
        }
    };

    async onUploadSuccess(args: any) {
        let file = args.file;
        let rawFile = file.rawFile;
        const warnings = await this.diagram.importFromVisio(rawFile, { pageIndex: 0 });
        if (warnings.length) {
            for (var i = 0; i < warnings.length - 1; i++) {
                console.warn(warnings[i]);
            }
        }
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Import options

Import behavior can be customized using the VisioImportOptions object.

Property Description
pageIndex Specifies the zero-based index of the Visio page to import. The default value is 0.

Import lifecycle event

The diagramImporting event is triggered during the Visio import process. This event provides information about the current import status, available pages, warnings or errors, and supports page selection or cancellation of the import operation.

Event arguments:

Argument Description
status Indicates the current stage of the import operation.
pages Contains the list of available Visio pages.
selectedPage Specifies the Visio page to import.
cancel Set to true to cancel the import operation.
logs Contains warnings or errors generated during import.

NOTE

The selectedPage property is configurable only when the import status is started.

Cancel the import operation

The import operation can be canceled during the initial stage by setting the cancel property to true.

public diagramImporting(args: IImportingEventArgs): void {
  if (args.status === 'started') {
    args.cancel = true;
  }
}

Select a page during import

When a Visio file contains multiple pages, a specific page can be selected at the start of the import process.

public diagramImporting(args: IImportingEventArgs): void {
  if (args.status === 'started' && args.pages && args.pages.length) {
    args.selectedPage = args.pages[0]; // Imports the first page
  }
}

Export Angular Diagram to Visio

How Visio export works

The Diagram component supports exporting diagrams to Microsoft Visio format using the exportToVisio method. This method generates a .vsdx file and automatically downloads it through the browser.

Exporting a diagram

The following example exports an Angular Diagram to a Microsoft Visio (.vsdx) file using the exportToVisio method.

import { DiagramModule, ImportAndExportVisio, DiagramComponent, Diagram, IExportingEventArgs,NodeModel, ConnectorModel,VisioExportOptions } from '@syncfusion/ej2-angular-diagrams';
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';

Diagram.Inject(ImportAndExportVisio);

@Component({
    imports: [DiagramModule],
    providers: [],
    standalone: true,
    selector: 'app-container',
    template: `
    <button (click)="export()">Export</button>
    <ejs-diagram #diagram id="diagram" width="100%" height="700px" [nodes]='nodes' [connectors]='connectors' (diagramExporting)="diagramExporting($event)">
    </ejs-diagram>`,
    encapsulation: ViewEncapsulation.None,
})

export class AppComponent {
    @ViewChild('diagram')
    public diagram!: DiagramComponent;
    public nodes: NodeModel[] = [
        {
            id: 'Start',
            width: 100,
            height: 100,
            offsetX: 300,
            offsetY: 200,
            annotations: [
                {
                    content: 'Start',
                }
            ],
            ports: [{
                id: 'port1',
                offset: {
                    x: 1,
                    y: 0.5
                }
            }],
            style: { fill: '#2AA8D9', strokeColor: 'grey' }
        },
        {
            id: 'End',
            width: 100,
            height: 100,
            offsetX: 600,
            offsetY: 200,
            annotations: [
                {
                    content: 'End',

                }
            ],
            style: { fill: '#2AA8D9', strokeColor: 'grey' }
        }
    ];
    public connectors: ConnectorModel[] = [
        {
            id: 'connector1',
            sourceID: 'Start',
            sourcePortID: 'port1',
            targetID: 'End',
            annotations: [
                {
                    content: 'Connect',
                    alignment: 'Before',
                    displacement: { y: 10 },
                }
            ]
        }
    ];

    public diagramExporting(args: IExportingEventArgs): void {
        if (args.status === 'started') {
            // Export has started: show a loader / disable UI
        } else if (args.status === 'completed') {
            // Export completed: hide loader / enable UI
        } else if (args.status === 'failed') {
            console.error('Visio export failed.', args);
        }
    };

    export() {
        let exportOptions: VisioExportOptions = {};
        exportOptions.fileName = 'diagram1.vsdx';
        exportOptions.pageName = 'page1';
        this.diagram.exportToVisio(exportOptions);
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Export options

Export behavior can be controlled using the VisioExportOptions object.

Property Description
fileName Specifies the name of the exported Visio file. The default value is Sample.vsdx.
pageName Specifies the name of the Visio page. The default value is Page-1.

Export lifecycle event

The diagramExporting event provides status updates, reports warnings or errors, and supports cancellation of the export operation.

Event arguments:

Argument Description
status Indicates the current stage of the export process.
cancel Set to true to cancel the export operation.
logs Contains warnings or errors generated during export.

Cancel the export operation

The export operation can be canceled at the start of the process by setting the cancel property to true.

  public diagramExporting(args: IExportingEventArgs): void{
    if (args.status === 'started') {
      args.cancel = true;
    }
  }

Limitations

The table below outlines Visio’s import and export limitations, offering a concise summary of current feature support and known restrictions.

Import Limitations Export Limitations
Gradient page backgrounds: Only solid fills are imported; gradient page background fills are not supported. Diagram-level tooltips: Diagram‑level tooltips are not exported.
Gradient types: Only linear and radial gradient types are supported; other gradient styles are ignored. Connector segment thumbs: Connector segment thumb customizations are not supported.
Ruler settings: Ruler settings may not be preserved accurately due to coordinate origin differences (Visio uses bottom‑left; Diagram component uses top‑left). Templates & tools: Templates and custom tool configurations are not exported.
Layer support: Only a single layer per shape is supported. Layer Z‑index ordering: Layer Z‑index ordering is not preserved.
Line styles: Rounded line caps and compound line styles are not supported. Annotation properties: Annotation displacement and flip properties are not supported.
Image formatting: Image formatting options such as brightness, contrast, and cropping are not supported. Port customization: Port customization properties are not exported.
Connector types: Only basic connector types—straight, right‑angle, and curved—are supported. Page margins & boundaries: Page margin and boundary constraints may require manual adjustment after export.
Connector gradients: Connector gradient styles are not supported.  
Multiple hyperlinks: Multiple hyperlinks within a single shape are not supported.  
Rich text: Rich text formatting is not supported; text is rendered using a single, uniform style.  
Text fill behavior: Text fill behavior may differ from Microsoft Visio.

Import and Export Visio files

NOTE

Visio import and export support is currently experimental. Certain features may be limited or may not function as expected.

What is Microsoft Visio?

Microsoft Visio is a diagramming application used to create visual representations such as flowcharts, organizational charts, process diagrams, and system layouts. Visio diagrams are stored in the .vsdx file format, which contains information about pages, shapes, connectors, text, and layout settings.

Why use Visio with the Vue Diagram?

Many organizations maintain existing diagrams created using Microsoft Visio. Recreating these diagrams in a web application can require significant effort. The Diagram component provides Visio integration to support the following scenarios:

  • Reuse existing Visio diagrams in web applications.
  • Visualize and edit Visio diagrams using the Diagram component.
  • Export diagrams created or modified in Diagram component for use in Microsoft Visio.

This integration enables seamless collaboration between desktop‑based Visio tools and web‑based diagramming applications.

Visio support in the Vue Diagram

The Syncfusion Essential Vue Diagram component supports Microsoft Visio integration by allowing .vsdx files to be imported into the Diagram component and diagrams to be exported back to Visio format. During import, Visio shapes, connectors, and annotations are mapped to their corresponding Diagram elements, while export converts the diagram content into a valid .vsdx file.

NOTE

To enable Visio import and export functionality, inject the ImportAndExportVisio module into the Diagram component.

Import Visio files in Vue Diagram

How Visio import works

A Visio file can be selected from the local file system or retrieved from a server or cloud storage. Once the .vsdx file is available, it is passed to the Diagram component as a File object using the importFromVisio method.

During the import process:

  • Visio pages are read.
  • Shapes are converted into Diagram nodes.
  • Connectors are converted into Diagram connectors.
  • Basic text and formatting are applied where supported.

Import a Visio file

The following example imports a Visio (.vsdx) file by passing a File object to the importFromVisio method. The method returns a collection of warnings when certain Visio features are not fully supported during import.

<template>
    <div id="app">
      <ejs-uploader ref="uploadObj" id="defaultfileupload" name="UploadFiles" :asyncSettings="path"
        :success="onUploadSuccess" :allowedExtensions="'.vsdx'"></ejs-uploader>
  
      <ejs-diagram id="diagram" ref="diagramObj" :width='width' :height='height' :diagramImporting='diagramImporting'></ejs-diagram>
  
    </div>
  </template>
  
  <script setup>
  import { provide, ref, onMounted } from "vue";
  import { DiagramComponent as EjsDiagram, ImportAndExportVisio } from '@syncfusion/ej2-vue-diagrams';
  import { UploaderComponent as EjsUploader } from '@syncfusion/ej2-vue-inputs';
  
  let diagramInstance;
  let diagramObj = ref(null);
  
  const width = "1000px";
  const height = "700px";
  const diagramImporting = function() {
    if (args.status === 'started') {
        // Import has started: show a loader / disable UI
    } else if (args.status === 'completed') {
        // Import completed: hide loader / enable UI
    } else if (args.status === 'failed') {
        console.error('Visio import failed.', args);
    }
  }
  const path = {
    saveUrl:
      'https://services.syncfusion.com/vue/production/api/FileUploader/Save',
    removeUrl:
      'https://services.syncfusion.com/vue/production/api/FileUploader/Remove',
  };
  
  onMounted(function () {
    diagramInstance = diagramObj.value.ej2Instances;
  })

  const onUploadSuccess = async (args) => {
    let file = args.file;
    let rawFile = file.rawFile;
    const warnings = await diagramInstance.importFromVisio(rawFile, { pageIndex: 0 });
    if (warnings.length) {
        for (var i = 0; i < warnings.length - 1; i++) {
        console.warn(warnings[i]);
        }
    }
  }
  
  provide('diagram', [ImportAndExportVisio]);
  
  </script>
  
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-uploader ref="uploadObj" id="defaultfileupload" name="UploadFiles" :asyncSettings="path"
        :success="onUploadSuccess" :allowedExtensions="'.vsdx'"></ejs-uploader>
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :diagramImporting='diagramImporting'></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent, ImportAndExportVisio } from '@syncfusion/ej2-vue-diagrams';
import { UploaderComponent } from '@syncfusion/ej2-vue-inputs';

let diagramInstance;

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
        'ejs-uploader': UploaderComponent,
    },
    data() {
        return {
            width: '100%',
            height: '700px',
            diagramImporting: (args) => {
                if (args.status === 'started') {
                    // Import has started: show a loader / disable UI
                } else if (args.status === 'completed') {
                    // Import completed: hide loader / enable UI
                } else if (args.status === 'failed') {
                    console.error('Visio import failed.', args);
                }
            },
            path: {
                saveUrl:
                    'https://services.syncfusion.com/vue/production/api/FileUploader/Save',
                removeUrl:
                    'https://services.syncfusion.com/vue/production/api/FileUploader/Remove',
            }
        };
    },
    methods: {
        async onUploadSuccess(args) {
            let file = args.file;
            let rawFile = file.rawFile;
            const warnings = await diagramInstance.importFromVisio(rawFile, { pageIndex: 0 });
            if (warnings.length) {
                for (var i = 0; i < warnings.length - 1; i++) {
                console.warn(warnings[i]);
                }
            }
        },

    },
    mounted: function () {
        diagramInstance = this.$refs.diagramObj.ej2Instances;
    },
    provide: { diagram: [ImportAndExportVisio] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Import options

Import behavior can be customized using the VisioImportOptions object.

Property Description
pageIndex Specifies the zero-based index of the Visio page to import. The default value is 0.

Import lifecycle event

The diagramImporting event is triggered during the Visio import process. This event provides information about the current import status, available pages, warnings or errors, and supports page selection or cancellation of the import operation.

Event arguments:

Argument Description
status Indicates the current stage of the import operation.
pages Contains the list of available Visio pages.
selectedPage Specifies the Visio page to import.
cancel Set to true to cancel the import operation.
logs Contains warnings or errors generated during import.

NOTE

The selectedPage property is configurable only when the import status is started.

Cancel the import operation

The import operation can be canceled during the initial stage by setting the cancel property to true.

diagramImporting: function (args: IImportingEventArgs) {
  if (args.status === 'started') {
    args.cancel = true;
  }
}

Select a page during import

When a Visio file contains multiple pages, a specific page can be selected at the start of the import process.

diagramImporting: function (args: IImportingEventArgs) {
  if (args.status === 'started' && args.pages && args.pages.length) {
    args.selectedPage = args.pages[0]; // Imports the first page
  }
}

Export Vue Diagram to Visio

How Visio export works

The Diagram component supports exporting diagrams to Microsoft Visio format using the exportToVisio method. This method generates a .vsdx file and automatically downloads it through the browser.

Exporting a diagram

The following example exports an Vue Diagram to a Microsoft Visio (.vsdx) file using the exportToVisio method.

<template>
    <div id="app">
      <button v-on:click="exportVisio">Export</button>
  
      <ejs-diagram id="diagram" ref="diagramObj" :width='width' :height='height' :nodes="nodes" :connectors="connectors" :diagramExporting="diagramExporting"></ejs-diagram>
  
    </div>
</template>
  
  <script setup>
    import { provide, ref, onMounted } from "vue";
    import { DiagramComponent as EjsDiagram, ImportAndExportVisio } from '@syncfusion/ej2-vue-diagrams';
    
    let diagramInstance;
    let diagramObj = ref(null);
    
    let nodes = [
        {
            id: 'Start',
            width: 100,
            height: 100,
            offsetX: 300,
            offsetY: 200,
            annotations: [
                {
                    content: 'Start',
                }
            ],
            ports: [{
                id: 'port1',
                offset: {
                    x: 1,
                    y: 0.5
                }
            }],
            style: { fill: '#2AA8D9', strokeColor: 'grey' }
        },
        {
            id: 'End',
            width: 100,
            height: 100,
            offsetX: 600,
            offsetY: 200,
            annotations: [
                {
                    content: 'End',

                }
            ],
            style: { fill: '#2AA8D9', strokeColor: 'grey' }
        }
    ];

    let connectors = [
        {
            id: 'connector1',
            sourceID: 'Start',
            sourcePortID: 'port1',
            targetID: 'End',
            annotations: [
                {
                    content: 'Connect',
                    alignment: 'Before',
                    displacement: { y: 10 },
                }
            ]
        }
    ];
    
    const width = "1000px";
    const height = "700px";
    const diagramExporting = function() {
        if (args.status === 'started') {
            // Export has started: show loader / disable UI
        }
        else if (args.status === 'completed') {
            // Export completed: hide loader / enable UI
        }
        else if (args.status === 'failed') {
            // Export failed: show error message
            console.error('Visio export failed.', args);
        }
    }

    const exportVisio = () => {
        let exportOptions = {};
        exportOptions.fileName = 'diagram1.vsdx';
        exportOptions.pageName = 'page1';
        diagramInstance.exportToVisio(exportOptions);
    };

    onMounted(function () {
        diagramInstance = diagramObj.value.ej2Instances;
    })
    
    provide('diagram', [ImportAndExportVisio]);
  
  </script>
  
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <button v-on:click="exportVisio">Export</button>
        <ejs-diagram id="diagram" ref="diagramObj" :width="width" :height="height" :nodes="nodes" :connectors="connectors" :diagramExporting="diagramExporting"></ejs-diagram>
    </div>
</template>

<script>
import { DiagramComponent, ImportAndExportVisio } from '@syncfusion/ej2-vue-diagrams';

var diagramInstance;

var nodes = [
    {
        id: 'Start',
        width: 100,
        height: 100,
        offsetX: 300,
        offsetY: 200,
        annotations: [
            {
                content: 'Start',
            }
        ],
        ports: [{
            id: 'port1',
            offset: {
                x: 1,
                y: 0.5
            }
        }],
        style: { fill: '#2AA8D9', strokeColor: 'grey' }
    },
    {
        id: 'End',
        width: 100,
        height: 100,
        offsetX: 600,
        offsetY: 200,
        annotations: [
            {
                content: 'End',

            }
        ],
        style: { fill: '#2AA8D9', strokeColor: 'grey' }
    }
];

let connectors = [
    {
        id: 'connector1',
        sourceID: 'Start',
        sourcePortID: 'port1',
        targetID: 'End',
        annotations: [
            {
                content: 'Connect',
                alignment: 'Before',
                displacement: { y: 10 },
            }
        ]
    }
];

export default {
    name: 'App',
    components: {
        'ejs-diagram': DiagramComponent,
    },
    data() {
        return {
            width: '100%',
            height: '700px',
            nodes: nodes,
            connectors: connectors,
            diagramExporting: (args) => {
                if (args.status === 'started') {
                    // Export has started: show loader / disable UI
                }
                else if (args.status === 'completed') {
                    // Export completed: hide loader / enable UI
                }
                else if (args.status === 'failed') {
                    // Export failed: show error message
                    console.error('Visio export failed.', args);
                }
            },
        };
    },
    methods: {
        exportVisio() {
            let exportOptions = {};
            exportOptions.fileName = 'diagram1.vsdx';
            exportOptions.pageName = 'page1';
            diagramInstance.exportToVisio(exportOptions);
        },
    },
    mounted: function () {
        diagramInstance = this.$refs.diagramObj.ej2Instances;
    },
    provide: { diagram: [ImportAndExportVisio] },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Export options

Export behavior can be controlled using the VisioExportOptions object.

Property Description
fileName Specifies the name of the exported Visio file. The default value is Sample.vsdx.
pageName Specifies the name of the Visio page. The default value is Page-1.

Export lifecycle event

The diagramExporting event provides status updates, reports warnings or errors, and supports cancellation of the export operation.

Event arguments:

Argument Description
status Indicates the current stage of the export process.
cancel Set to true to cancel the export operation.
logs Contains warnings or errors generated during export.

Cancel the export operation

The export operation can be canceled at the start of the process by setting the cancel property to true.

  diagramExporting: function (args: IExportingEventArgs) {
    if (args.status === 'started') {
      args.cancel = true;
    }
  }

Limitations

The table below outlines Visio’s import and export limitations, offering a concise summary of current feature support and known restrictions.

Import Limitations Export Limitations
Gradient page backgrounds: Only solid fills are imported; gradient page background fills are not supported. Diagram-level tooltips: Diagram‑level tooltips are not exported.
Gradient types: Only linear and radial gradient types are supported; other gradient styles are ignored. Connector segment thumbs: Connector segment thumb customizations are not supported.
Ruler settings: Ruler settings may not be preserved accurately due to coordinate origin differences (Visio uses bottom‑left; Diagram component uses top‑left). Templates & tools: Templates and custom tool configurations are not exported.
Layer support: Only a single layer per shape is supported. Layer Z‑index ordering: Layer Z‑index ordering is not preserved.
Line styles: Rounded line caps and compound line styles are not supported. Annotation properties: Annotation displacement and flip properties are not supported.
Image formatting: Image formatting options such as brightness, contrast, and cropping are not supported. Port customization: Port customization properties are not exported.
Connector types: Only basic connector types—straight, right‑angle, and curved—are supported. Page margins & boundaries: Page margin and boundary constraints may require manual adjustment after export.
Connector gradients: Connector gradient styles are not supported.  
Multiple hyperlinks: Multiple hyperlinks within a single shape are not supported.  
Rich text: Rich text formatting is not supported; text is rendered using a single, uniform style.  
Text fill behavior: Text fill behavior may differ from Microsoft Visio.

Import and Export Visio files

NOTE

Visio import and export support is currently experimental. Certain features may be limited or may not function as expected.

What is Microsoft Visio?

Microsoft Visio is a diagramming application used to create visual representations such as flowcharts, organizational charts, process diagrams, and system layouts. Visio diagrams are stored in the .vsdx file format, which contains information about pages, shapes, connectors, text, and layout settings.

Why use Visio with the React Diagram?

Many organizations maintain existing diagrams created using Microsoft Visio. Recreating these diagrams in a web application can require significant effort. The Diagram component provides Visio integration to support the following scenarios:

  • Reuse existing Visio diagrams in web applications.
  • Visualize and edit Visio diagrams using the Diagram component.
  • Export diagrams created or modified in Diagram component for use in Microsoft Visio.

This integration enables seamless collaboration between desktop‑based Visio tools and web‑based diagramming applications.

Visio support in the React Diagram

The Syncfusion Essential React Diagram component supports Microsoft Visio integration by allowing .vsdx files to be imported into the Diagram component and diagrams to be exported back to Visio format. During import, Visio shapes, connectors, and annotations are mapped to their corresponding Diagram elements, while export converts the diagram content into a valid .vsdx file.

NOTE

To enable Visio import and export functionality, inject the ImportAndExportVisio module into the Diagram component.

Import Visio files in React Diagram

How Visio import works

A Visio file can be selected from the local file system or retrieved from a server or cloud storage. Once the .vsdx file is available, it is passed to the Diagram component as a File object using the importFromVisio method.

During the import process:

  • Visio pages are read.
  • Shapes are converted into Diagram nodes.
  • Connectors are converted into Diagram connectors.
  • Basic text and formatting are applied where supported.

Import a Visio file

The following example imports a Visio (.vsdx) file by passing a File object to the importFromVisio method. The method returns a collection of warnings when certain Visio features are not fully supported during import.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, ImportAndExportVisio } from "@syncfusion/ej2-react-diagrams";
import { UploaderComponent } from '@syncfusion/ej2-react-inputs';

export default function App() {
  let diagramInstance;

  let uploadObject = {
    saveUrl:
      'https://services.syncfusion.com/js/production/api/FileUploader/Save',
    removeUrl:
      'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
  };

  async function onUploadSuccess(args) {
    var file = args.file;
    var rawFile = file.rawFile;
    const warnings = await diagramInstance.importFromVisio(rawFile, { pageIndex: 0 });
    if (warnings.length) {
      for (var i = 0; i < warnings.length - 1; i++) {
        console.warn(warnings[i]);
      }
    }
  };

  return (
    // Initialize Diagram component
    <div>
      <UploaderComponent asyncSettings={uploadObject} success={onUploadSuccess} allowedExtensions={".vsdx"}/>
      <DiagramComponent
        id="container"
        ref={(diagram) => (diagramInstance = diagram)}
        width={'100%'}
        height={'700px'}
        diagramImporting={
          (args) => {
            if (args.status === 'started') {
              // Import has started: show a loader / disable UI
            } else if (args.status === 'completed') {
              // Import completed: hide loader / enable UI
            } else if (args.status === 'failed') {
              console.error('Visio import failed.', args);
            }
          }
        }

      >
        <Inject services={[ImportAndExportVisio]} />
      </DiagramComponent>
    </div>
  );
};

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, ImportAndExportVisio, IImportingEventArgs} from "@syncfusion/ej2-react-diagrams";
import { UploaderComponent, FileInfo } from '@syncfusion/ej2-react-inputs';

export default function App() {
  let diagramInstance: DiagramComponent;

  let uploadObject = {
      saveUrl:
        'https://services.syncfusion.com/js/production/api/FileUploader/Save',
      removeUrl:
        'https://services.syncfusion.com/js/production/api/FileUploader/Remove',
    }
  
  async function onUploadSuccess(args) {
    let file = args.file;
    let rawFile = file.rawFile;
    const warnings = await diagramInstance.importFromVisio(rawFile, { pageIndex: 0 });
    if (warnings.length) {
      for (var i = 0; i < warnings.length - 1; i++) {
        console.warn(warnings[i]);
      }
    }
  }

  return (
    // Initialize Diagram component
    <div>
      <UploaderComponent asyncSettings={uploadObject} success={onUploadSuccess} allowedExtensions={".vsdx"} />
      <DiagramComponent
        id="container"
        ref={(diagram: any) => (diagramInstance = diagram)}
        width={'100%'}
        height={'700px'}
        diagramImporting={
          (args: IImportingEventArgs) => {
            if (args.status === 'started') {
              // Import has started: show a loader / disable UI
            } else if (args.status === 'completed') {
              // Import completed: hide loader / enable UI
            } else if (args.status === 'failed') {
              console.error('Visio import failed.', args);
            }
          }
        }
      >
        <Inject services={[ImportAndExportVisio]} />
      </DiagramComponent>
    </div>
  );
};

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Import options

Import behavior can be customized using the VisioImportOptions object.

Property Description
pageIndex Specifies the zero-based index of the Visio page to import. The default value is 0.

Import lifecycle event

The diagramImporting event is triggered during the Visio import process. This event provides information about the current import status, available pages, warnings or errors, and supports page selection or cancellation of the import operation.

Event arguments:

Argument Description
status Indicates the current stage of the import operation.
pages Contains the list of available Visio pages.
selectedPage Specifies the Visio page to import.
cancel Set to true to cancel the import operation.
logs Contains warnings or errors generated during import.

NOTE

The selectedPage property is configurable only when the import status is started.

Cancel the import operation

The import operation can be canceled during the initial stage by setting the cancel property to true.

diagramImporting: function (args: IImportingEventArgs) {
  if (args.status === 'started') {
    args.cancel = true;
  }
}

Select a page during import

When a Visio file contains multiple pages, a specific page can be selected at the start of the import process.

diagramImporting: function (args: IImportingEventArgs) {
  if (args.status === 'started' && args.pages && args.pages.length) {
    args.selectedPage = args.pages[0]; // Imports the first page
  }
}

Export React Diagram to Visio

How Visio export works

The Diagram component supports exporting diagrams to Microsoft Visio format using the exportToVisio method. This method generates a .vsdx file and automatically downloads it through the browser.

Exporting a diagram

The following example exports an React Diagram to a Microsoft Visio (.vsdx) file using the exportToVisio method.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, ImportAndExportVisio } from "@syncfusion/ej2-react-diagrams";

export default function App() {
  let diagramInstance;

  let nodes = [
    {
      id: 'Start',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 200,
      annotations: [
        {
          content: 'Start',
        }
      ],
      ports: [{
        id: 'port1',
        offset: {
          x: 1,
          y: 0.5
        }
      }],
      style: { fill: '#2AA8D9', strokeColor: 'grey' }
    },
    {
      id: 'End',
      width: 100,
      height: 100,
      offsetX: 600,
      offsetY: 200,
      annotations: [
        {
          content: 'End',

        }
      ],
      style: { fill: '#2AA8D9', strokeColor: 'grey' }
    }
  ];

  let connectors = [
    {
      id: 'connector1',
      sourceID: 'Start',
      sourcePortID: 'port1',
      targetID: 'End',
      annotations: [
        {
          content: 'Connect',
          alignment: 'Before',
          displacement: { y: 10 },
        }
      ]
    }
  ];

  function exportVisio() {
    let exportOptions = {};
    exportOptions.fileName = 'diagram1.vsdx';
    exportOptions.pageName = 'page1';
    diagramInstance.exportToVisio(exportOptions);
  };

  return (
    // Initialize Diagram component
    <div>
      <button id="export" onClick={exportVisio}>Export</button>
      <DiagramComponent
        id="container"
        ref={(diagram) => (diagramInstance = diagram)}
        width={'100%'}
        height={'700px'}
        nodes={nodes}
        connectors={connectors}
        diagramExporting={
          (args) => {
            if (args.status === 'started') {
              // Export has started: show a loader / disable UI
            } else if (args.status === 'completed') {
              // Export completed: hide loader / enable UI
            } else if (args.status === 'failed') {
              console.error('Visio export failed.', args);
            }
          }
        }
      >
        <Inject services={[ImportAndExportVisio]} />
      </DiagramComponent>
    </div>
  );
};

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram"));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, Inject, ImportAndExportVisio, VisioExportOptions, IExportingEventArgs, NodeModel, ConnectorModel } from "@syncfusion/ej2-react-diagrams";

export default function App() {
  let diagramInstance: DiagramComponent;

  let nodes: NodeModel[] = [
    {
      id: 'Start',
      width: 100,
      height: 100,
      offsetX: 300,
      offsetY: 200,
      annotations: [
        {
          content: 'Start',
        }
      ],
      ports: [{
        id: 'port1',
        offset: {
          x: 1,
          y: 0.5
        }
      }],
      style: { fill: '#2AA8D9', strokeColor: 'grey' }
    },
    {
      id: 'End',
      width: 100,
      height: 100,
      offsetX: 600,
      offsetY: 200,
      annotations: [
        {
          content: 'End',

        }
      ],
      style: { fill: '#2AA8D9', strokeColor: 'grey' }
    }
  ];

  let connectors: ConnectorModel[] = [
    {
      id: 'connector1',
      sourceID: 'Start',
      sourcePortID: 'port1',
      targetID: 'End',
      annotations: [
        {
          content: 'Connect',
          alignment: 'Before',
          displacement: { y: 10 },
        }
      ]
    }
  ];


  function exportVisio() {
    let exportOptions: VisioExportOptions = {};
    exportOptions.fileName = 'diagram1.vsdx';
    exportOptions.pageName = 'page1';
    diagramInstance.exportToVisio(exportOptions);
  };

  return (
    // Initialize Diagram component
    <div>
      <button id="export" onClick={exportVisio}>Export</button>
      <DiagramComponent
        id="container"
        ref={(diagram: any) => (diagramInstance = diagram)}
        width={'100%'}
        height={'700px'}
        nodes={nodes}
        connectors={connectors}
        diagramExporting={
          (args: IExportingEventArgs) => {
            if (args.status === 'started') {
              // Export has started: show a loader / disable UI
            } else if (args.status === 'completed') {
              // Export completed: hide loader / enable UI
            } else if (args.status === 'failed') {
              console.error('Visio export failed.', args);
            }
          }
        }

      >
        <Inject services={[ImportAndExportVisio]} />
      </DiagramComponent>
    </div>
  );
};

// Render the App component into the 'diagram' element in the DOM
const root = ReactDOM.createRoot(document.getElementById("diagram") as HTMLElement);
root.render(<App />);

Export options

Export behavior can be controlled using the VisioExportOptions object.

Property Description
fileName Specifies the name of the exported Visio file. The default value is Sample.vsdx.
pageName Specifies the name of the Visio page. The default value is Page-1.

Export lifecycle event

The diagramExporting event provides status updates, reports warnings or errors, and supports cancellation of the export operation.

Event arguments:

Argument Description
status Indicates the current stage of the export process.
cancel Set to true to cancel the export operation.
logs Contains warnings or errors generated during export.

Cancel the export operation

The export operation can be canceled at the start of the process by setting the cancel property to true.

  diagramExporting: function (args: IExportingEventArgs) {
    if (args.status === 'started') {
      args.cancel = true;
    }
  }

Limitations

The table below outlines Visio’s import and export limitations, offering a concise summary of current feature support and known restrictions.

Import Limitations Export Limitations
Gradient page backgrounds: Only solid fills are imported; gradient page background fills are not supported. Diagram-level tooltips: Diagram‑level tooltips are not exported.
Gradient types: Only linear and radial gradient types are supported; other gradient styles are ignored. Connector segment thumbs: Connector segment thumb customizations are not supported.
Ruler settings: Ruler settings may not be preserved accurately due to coordinate origin differences (Visio uses bottom‑left; Diagram component uses top‑left). Templates & tools: Templates and custom tool configurations are not exported.
Layer support: Only a single layer per shape is supported. Layer Z‑index ordering: Layer Z‑index ordering is not preserved.
Line styles: Rounded line caps and compound line styles are not supported. Annotation properties: Annotation displacement and flip properties are not supported.
Image formatting: Image formatting options such as brightness, contrast, and cropping are not supported. Port customization: Port customization properties are not exported.
Connector types: Only basic connector types—straight, right‑angle, and curved—are supported. Page margins & boundaries: Page margin and boundary constraints may require manual adjustment after export.
Connector gradients: Connector gradient styles are not supported.  
Multiple hyperlinks: Multiple hyperlinks within a single shape are not supported.  
Rich text: Rich text formatting is not supported; text is rendered using a single, uniform style.  
Text fill behavior: Text fill behavior may differ from Microsoft Visio.